/*
 * libjingle
 * Copyright 2013, Google Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <UIKit/UIKit.h>

@class APPRTCVideoView;

@protocol VideoViewDelegate <NSObject>

- (void)iAmTapped:(APPRTCVideoView*)vidView;

@end

/**
 @abstract This class encapsulates the video view returned from the SKYLINKFramework.
 */
@interface APPRTCVideoView : UIView

@property(nonatomic, unsafe_unretained) BOOL isEnable;
@property(nonatomic, unsafe_unretained) BOOL isRemote;

@property(nonatomic, weak) id<VideoViewDelegate> delegate;

@property(nonatomic, copy) NSString *ID;
@property(nonatomic, weak) NSString *title;

@property(nonatomic, assign) UIInterfaceOrientation videoOrientation;

@property(nonatomic, weak) UILabel* lblTitle;
@property(nonatomic, weak) UIView* renderView;

- (id)initWithFrame:(CGRect)frame videoView:(UIView*)videoView;

- (void)addProgressView;
- (void)layoutMySubviews:(CGSize)size;
- (void)removeProgressView;

@end
