//
//  ViewController.swift
//  TestSwift
//
//  Created by macbookpro on 06/01/2015.
//  Copyright (c) 2015 Temasys Communications. All rights reserved.
//

import UIKit

class ViewController: UIViewController, SKYLINKConnectionLifeCycleDelegate, SKYLINKConnectionRemotePeerDelegate, SKYLINKConnectionMediaDelegate {

    var myConnection : SKYLINKConnection?
    
    var myVideoView : UIView?
    var myVideoViewSize : CGSize?
    var myVideoViewFrame : CGRect?
    
    var yourVideoView : UIView?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        var config : SKYLINKConnectionConfig = SKYLINKConnectionConfig()
        config.audio = true
        config.video = true
        config.dataChannel = true
        config.fileTransfer = true
        myConnection = SKYLINKConnection(config: config, apiKey: <#api key#>)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func viewDidAppear(animated: Bool) {
        myConnection?.lifeCycleDelegate = self;
        myConnection?.remotePeerDelegate = self;
        myConnection?.mediaDelegate = self;
        myConnection?.connectToRoomWithSecret(<#secret#>, roomName: <#room name#>, userInfo: <#display name#>)
    }

    override func shouldAutorotate() -> Bool {
        return false
    }
    
    func connection(connection: SKYLINKConnection!, didConnectWithMessage errorMessage: String!, success isSuccess: Bool) {
        NSLog("isSuccess->%i", isSuccess)
    }
    
    func connection(connection: SKYLINKConnection!, didRenderUserVideo userVideoView: UIView!) {
        myVideoViewFrame = CGRectMake(0, 0, self.view.bounds.width/3, self.view.bounds.height/3)
        // Since this sample application doesn't support video capture rotation
        // userVideoView.transform = CGAffineTransformMakeScale(-1, 1);
        userVideoView.frame = self.view.bounds
        self.view.addSubview(userVideoView)
        self.myVideoView = userVideoView
    }
    
    func connection(connection: SKYLINKConnection!, didRenderPeerVideo peerVideoView: UIView!, peerId: String!) {
        self.myVideoView?.frame = self.myVideoViewFrame!
        self.layoutSubViews(self.myVideoView!, renderSize: self.myVideoViewSize!, parentFrame: self.myVideoViewFrame!)
        peerVideoView?.frame = self.view.bounds
        self.view.insertSubview(peerVideoView, belowSubview: self.myVideoView!)
        self.yourVideoView = peerVideoView
    }
    
    func connection(connection: SKYLINKConnection!, didChangeVideoSize videoSize: CGSize, videoView: UIView!) {
        if (videoView == self.myVideoView) {
            self.myVideoViewSize = videoSize
            if (self.yourVideoView == nil) {
                self.layoutSubViews(videoView, renderSize: videoSize, parentFrame: self.view.bounds)
            } else {
                self.layoutSubViews(videoView, renderSize: videoSize, parentFrame: self.myVideoViewFrame!)
            }
        } else if (videoView == self.yourVideoView) {
            self.layoutSubViews(videoView, renderSize: videoSize, parentFrame: self.view.bounds)
        }
    }
    
    func connection(connection: SKYLINKConnection!, didLeavePeerWithMessage errorMessage: String!, peerId: String!) {
        self.yourVideoView?.removeFromSuperview()
        self.yourVideoView = nil
        self.myVideoView?.frame = self.view.bounds
        self.layoutSubViews(self.myVideoView!, renderSize: self.myVideoViewSize!, parentFrame: self.view.bounds)
    }
    
    func layoutSubViews(videoView: UIView, renderSize: CGSize, parentFrame: CGRect) {
        if (renderSize.height > 0 && renderSize.width > 0) {
            let videoFrame: CGRect = AVMakeRectWithAspectRatioInsideRect(renderSize, parentFrame)
            videoView.frame = videoFrame
        }
    }
    
}

